' ====================================================================
' = HYDROXIDE'S (ANTI-ALIASED) STARFIELD VER. 1                 1999 =
' =------------------------------------------------------------------=
' = This program simulates a starfield via using "real" 3D math.     =
' = The code isn't really very easy to learn from, except for the    =
' = "apset" sub, which is well commented.                            =
' =                                                                  =
' = What sets this starfield apart from the others is the usage of   =                                                               
' = so-called "wu-lines" and "wu-particles", which basically mean    =
' = anti-aliased particles and lines (which create an effect of      =
' = motion-blurring; travelling in space at high speeds).            =
' =                                                                  =
' = No interactivity after the initalization.                        =
' =                                                                  =
' = As always, compiling is recommended for the best performance.    =
' =                                                                  =
' = Some optimization and heavy debugging by Entropy, whose site can =
' = be found at http://www.uslink.net.                               =
' =                                                                  =
' = Feel free to use the code, however, I do advice you to try to    =
' = LEARN from the code. Include SOME credits.                       =
' =                                                                  =
' = Copyright (c) 1999 hydroXide/wolverian aka Ilmari Vacklin.       =
' = Visit my site at http://fly.to/wolverian                         =
' = E-mail: hydroxide.v@usa.net                                      =
' ====================================================================

DECLARE FUNCTION deg2rad# (deg#)
DECLARE SUB aline2 (x1#, y1#, x2#, y2#, col%)
DECLARE SUB aline (x#, y#, x2#, y2#, col%)
DECLARE FUNCTION fract# (i#)
DECLARE FUNCTION invfract# (i#)
DECLARE SUB apset (x#, y#, col%)
DECLARE SUB pal (colour%, r%, g%, b%)
DECLARE SUB grad1 (col1%, r1%, g1%, b1%, col2%, r2%, g2%, b2%)
DEFINT A-Z

TYPE starType
  x AS DOUBLE
  y AS DOUBLE
  z AS DOUBLE
  x2 AS DOUBLE
  y2 AS DOUBLE
  oldx2 AS DOUBLE
  oldy2 AS DOUBLE
  vel AS DOUBLE
END TYPE

CONST maxVel = 14.5, minVel = 2.5

DO
  CLS : LOCATE 1, 1
  COLOR 7
  PRINT "hydroXide's starfield"
  PRINT ""
  INPUT "Amount of stars: ", amountOfStars
LOOP UNTIL amountOfStars > 0 AND amountOfStars < 10000

PRINT
PRINT "Keys:"
PRINT "a : anti-aliasing on/off."
PRINT "l : lines/pixels."
PRINT "p : randomize palette."
PRINT "r : restore palette."
PRINT "+/- : Maximum viewing distance (or star birth distance)."
PRINT "d : show variables (debug mode)."
PRINT "ESC : Guess. =)"

DO: LOOP WHILE INKEY$ = ""

maxDistance = 900

DIM star(1 TO amountOfStars) AS starType

RANDOMIZE TIMER


FOR i = 1 TO UBOUND(star)
  star(i).x = RND * 1000 - 500
  star(i).y = RND * 1000 - 500
  star(i).z = RND * maxDistance + 100
  star(i).vel = RND * maxVel + minVel
  star(i).x2 = star(i).x / star(i).z * 100 + 160
  star(i).y2 = star(i).y / star(i).z * 100 + 100
  star(i).oldx2 = star(i).x2
  star(i).oldy2 = star(i).y2
NEXT i

SCREEN 13
COLOR 255

grad1 0, 0, 0, 0, 255, 63, 63, 63

centerX = 160
centerY = 100

DEF SEG = &HA000

anti = 1
mode = 1
stats = 0

DO
  FOR i = 1 TO UBOUND(star)
    x# = star(i).oldx2
    y# = star(i).oldy2
    x2# = star(i).x2
    y2# = star(i).y2
    IF mode = 1 THEN
      IF anti = 1 THEN
        aline2 x#, y#, x2#, y2#, 0
      ELSE
        LINE (x#, y#)-(x2#, y2#), 0
      END IF
    ELSE
      IF anti = 1 THEN
        apset x#, y#, 0
      ELSE
        PSET (x#, y#), 0
      END IF
    END IF

    star(i).z = star(i).z - star(i).vel
   
    star(i).oldx2 = star(i).x2
    star(i).oldy2 = star(i).y2
    star(i).x2 = star(i).x / star(i).z * 100 + centerX
    star(i).y2 = star(i).y / star(i).z * 100 + centerY

    'LOCATE 1, 1: PRINT star(i).x2; star(i).y2

    IF (star(i).z < 1) OR (star(i).x2 < 0) OR (star(i).x2 > 319) OR (star(i).y2 < 0) OR (star(i).y2 > 199) THEN
      star(i).x = RND * 1000 - 500
      star(i).y = RND * 1000 - 500
      star(i).z = RND * maxDistance + 100
      star(i).vel = RND * maxVel + minVel
      star(i).x2 = star(i).x / star(i).z * 100 + 160
      star(i).y2 = star(i).y / star(i).z * 100 + 100
      star(i).oldx2 = star(i).x2
      star(i).oldy2 = star(i).y2
    END IF
   
    x# = star(i).oldx2
    y# = star(i).oldy2
    x2# = star(i).x2
    y2# = star(i).y2
    b = 64 / star(i).z * maxDistance
    IF b > 255 THEN b = 255
    IF mode = 1 THEN
      IF anti = 1 THEN
        aline2 x#, y#, x2#, y2#, b
      ELSE
        LINE (x#, y#)-(x2#, y2#), b
      END IF
    ELSE
      IF anti = 1 THEN
        apset x#, y#, b
      ELSE
        PSET (x#, y#), b
      END IF
    END IF
   
    'b = ((255 / 5) * star(i).vel) * (1000 / star(i).z)
    'apset star(i).x2, star(i).y2, b
  NEXT i

  ar$ = LCASE$(INKEY$)
  SELECT CASE ar$
    CASE "p": grad1 0, 0, 0, 0, 255, CINT(RND * 63), CINT(RND * 63), CINT(RND * 63)
    CASE "a": anti = 1 - anti: CLS
    CASE "l": mode = 1 - mode: CLS
    CASE "+": maxDistance = maxDistance + 10
    CASE "-": maxDistance = maxDistance - 10
    CASE "r": grad1 0, 0, 0, 0, 255, 63, 63, 63
    CASE "d": stats = 1 - stats': CLS
    CASE CHR$(27): logOutMode = 1
    CASE ELSE
  END SELECT

  IF maxDistance > 5000 THEN maxDistance = 1
  IF maxDistance < 1 THEN maxDistance = 5000

  IF logOutMode = 1 THEN maxDistance = maxDistance - 10
  IF logOutMode = 1 AND maxDistance <= 0 THEN logOut = 1

  IF stats = 1 THEN
    LOCATE 1, 1: PRINT LTRIM$(RTRIM$(STR$(amountOfStars))); " stars with "; LTRIM$(RTRIM$(STR$(maxDistance))); " viewing distance."
    PRINT "Using ";
    IF anti = 1 THEN PRINT "anti-aliased ";
    IF mode = 1 THEN
      PRINT "lines."
    ELSE
      PRINT "pixels."
    END IF
  END IF
LOOP WHILE logOut = 0
  
DEF SEG

SCREEN 0
WIDTH 80, 25
PALETTE
CLS

PRINT "hydroXide's starfield, 1999."
PRINT "Version.. 0.1 beta I think. =) Visit my site at"
PRINT "http://fly.to/wolverian."
DO: LOOP UNTIL LEN(INKEY$)

SUB aline (x#, y#, x2#, y2#, col)

xd# = x2# - x#
yd# = y2# - y#

IF ABS(xd#) > ABS(yd#) THEN ' Horizontal lines.
  IF x# > x2# THEN
    SWAP x#, x2#
    SWAP y#, y2#
    xd# = -xd#
    yd# = -yd#
  END IF

  grad# = yd# / xd#

  ' End point 1.

  xend# = FIX(x# + .5)
  yend# = y#
 
  xgap# = invfract(x# - .5)

  ix = INT(xend#)
  iy = INT(yend#)

  brightness1# = invfract(yend#) * xgap#
  brightness2# = fract(yend#) * xgap#

  c1 = CINT(brightness1# * col)
  c2 = CINT(brightness2# * col)

  PSET (ix, iy), c1
  PSET (ix, iy + 1), c2

  yf# = yend + grad

  ' End point 2.

  xend# = FIX(x2# + .5)
  yend# = y2#

  xgap# = invfract(x2# - .5)

  ix2 = INT(xend#)
  iy2 = INT(yend#)

  brightness1# = invfract(yend#) * xgap#
  brightness2# = fract(yend#) * xgap#

  c1 = CINT(brightness1# * col)
  c2 = CINT(brightness2# * col)
  
  PSET (ix2, iy2), c1
  PSET (ix2, iy2 + 1), c2

  ' Main loop.

  FOR x = (ix + 1) TO (ix2 - 1)
    brightness1# = invfract(yf#)
    brightness2# = fract(yf#)
           
    c1 = CINT(brightness1# * col)
    c2 = CINT(brightness2# * col)
   
    PSET (x, INT(yf#)), c1
    PSET (x, INT(yf#) + 1), c2
               
    yf# = yf# + grad#
  NEXT x
ELSE
    IF ABS(yd#) = 0 THEN
        LINE (x#, y#)-(x2#, y2#), col
        EXIT SUB
    END IF
  IF y# > y2# THEN
    SWAP x#, x2#
    SWAP y#, y2#
    xd# = -xd#
    yd# = -yd#
  END IF

  grad# = xd# / yd#

  ' End point 1.

  yend# = FIX(y# + .5)
  xend# = x# '+ grad * (xend - x#)

  ygap# = invfract(y# - .5)

  ix = INT(xend#)
  iy = INT(yend#)

  brightness1# = invfract(xend#) * ygap#
  brightness2# = fract(xend#) * ygap#

  c1 = CINT(brightness1# * col)
  c2 = CINT(brightness2# * col)

  PSET (ix, iy), c1
  PSET (ix, iy + 1), c2

  xf# = xend# + grad#

  ' End point 2.

  yend# = FIX(y2# + .5)
  xend# = x2# '+ grad * (xend - x2#)

  ygap# = invfract(y2# - .5)

  ix2 = INT(xend#)
  iy2 = INT(yend#)

  brightness1# = invfract(xend#) * ygap#
  brightness2# = fract(xend#) * ygap#

  c1 = CINT(brightness1# * col)
  c2 = CINT(brightness2# * col)

  PSET (ix2, iy2), c1
  PSET (ix2, iy2 + 1), c2

  xf# = xend# + grad#

  ' Main loop.

  FOR y = (iy + 1) TO (iy2 - 1)
    brightness1# = invfract(xf#)
    brightness2# = fract(xf#)
          
    c1 = CINT(brightness1# * col)
    c2 = CINT(brightness2# * col)
  
    PSET (INT(xf#), y), c1
    PSET (INT(xf# + 1), y), c2
              
    xf# = xf# + grad#
  NEXT y
END IF



END SUB

SUB aline2 (x1#, y1#, x2#, y2#, col)

dx# = x2# - x1#
dy# = y2# - y1#

IF ABS(dx#) > ABS(dy#) THEN
    IF SGN(dx#) = -1 THEN
        SWAP x1#, x2#
        SWAP y1#, y2#
        dx# = -dx#
        dy# = -dy#
    END IF
    y# = y1#
    yg# = dy# / dx#
    FOR x = x1# TO x2#
        c1 = col * (INT(y#) + 1 - y#)
        c2 = col * (y# - INT(y#))
        IF c1 > col - 1 THEN c1 = col - 1
        IF c2 > col - 1 THEN c2 = col - 1
        IF c1 < 0 THEN c1 = 0
        IF c2 < 0 THEN c2 = 0
        'PSET (x, INT(y#)), c1
        'PSET (x, INT(y#) + 1), c2
        tempY = INT(y#) + 1: IF tempY > 199 THEN tempY = 199
        POKE (INT(y#) * 320&) + x, c1
        POKE (tempY * 320&) + x, c2
        y# = y# + yg#
    NEXT
ELSE
    IF dy# = 0 THEN
        c = col - 1
        IF c < 0 THEN c = 0
        LINE (x1#, y1#)-(x2#, y2#), c
        EXIT SUB
    END IF
    IF SGN(dy#) = -1 THEN
        SWAP x1#, x2#
        SWAP y1#, y2#
        dx# = -dx#
        dy# = -dy#
    END IF
    x# = x1#
    xg# = dx# / dy#
    FOR y = y1# TO y2#
        c1 = col * (INT(x#) + 1 - x#) '+ POINT(INT(x#), y)
        c2 = col * (x# - INT(x#)) '+ POINT(INT(x#) + 1, y)
        IF c1 > (col - 1) THEN c1 = (col - 1)
        IF c2 > (col - 1) THEN c2 = (col - 1)
        IF c1 < 0 THEN c1 = 0
        IF c2 < 0 THEN c2 = 0
        'PSET (INT(x#), y), c1
        'PSET (INT(x#) + 1, y), c2
        tempX = INT(x#) + 1: IF tempX > 319 THEN tempX = 319
        POKE (y * 320&) + x#, c1
        POKE (y * 320&) + tempX, c2
        x# = x# + xg#
    NEXT
END IF

END SUB

SUB apset (x#, y#, col)

' Let's find out the four pixels the particle
' covers: the first two we get by stripping the
' decimal partion from the n! value, and the rest
' two by adding 1 to the n% value.

x1 = FIX(x#)
y1 = FIX(y#)

x2 = x1 + 1
y2 = y1 + 1

' Here we find out how bright each of the four
' pixels should be. If n! is how much of the particle
' is placed in that pixel, and col% the brighntess
' of the particle, the formula is:
' brightness% = n! * col%
' How do we get the n!, then? Well, if xm! and
' ym! are the decimal portions of the coordinates,:
' (1 - xm!) * (1 - ym!) * col%
' does the job for the first pixel.

xm! = x# - x1
ym! = y# - y1

xm2! = (1 - xm!)
ym2! = (1 - ym!)

c1 = xm2! * ym2! * col
c2 = xm! * ym2! * col
c3 = xm2! * ym! * col
c4 = xm! * ym! * col

PSET (x1, y1), c1
PSET (x2, y1), c2
PSET (x1, y2), c3
PSET (x2, y2), c4

END SUB

FUNCTION deg2rad# (deg#)
deg2rad = deg# * 3.141593 / 180
END FUNCTION

FUNCTION fract# (i#)

fract# = ABS(i# - INT(i#))

END FUNCTION

'Makes a palette gradient
SUB grad1 (col1%, r1%, g1%, b1%, col2%, r2%, g2%, b2%)

cols% = col2% - col1% + 1
rstep# = (r2% - r1% + 1) / cols%
gstep# = (g2% - g1% + 1) / cols%
bstep# = (b2% - b1% + 1) / cols%
r# = r1%
g# = g1%
b# = b1%
FOR col% = col1% TO col2%
    r# = r# + rstep#
    g# = g# + gstep#
    b# = b# + bstep#
    IF r# > 63 THEN r# = 63
    IF r# < 0 THEN r# = 0
    IF g# > 63 THEN g# = 63
    IF g# < 0 THEN g# = 0
    IF b# > 63 THEN b# = 63
    IF b# < 0 THEN b# = 0
    pal col%, CINT(r#), CINT(g#), CINT(b#)
NEXT

END SUB

FUNCTION invfract# (i#)

invfract# = 1 - ABS(i# - INT(i#))

END FUNCTION

'change palette
SUB pal (colour%, r%, g%, b%)

OUT &H3C8, colour%
OUT &H3C9, r%
OUT &H3C9, g%
OUT &H3C9, b%

END SUB

